/*
 *    VisNow
 *    Copyright (C) 2006-2019 University of Warsaw, ICM
 *    Copyright (C) 2020 onward visnow.org
 *    All rights reserved. 
 * 
 *  DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
 *
 *  This code is free software; you can redistribute it and/or modify it
 *  under the terms of the GNU General Public License version 3, 
 *  or (at your option) any later version, as published by the Free Software Foundation.  
 *  The authors designate this particular file as subject to the "Classpath" exception 
 *  as provided in the LICENSE file that accompanied this code.
 *
 *  This code is distributed in the hope that it will be useful, but WITHOUT
 *  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 *  FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 *  version 3 for more details (a copy is included in the LICENSE file that
 *  accompanied this code).
 *
 *  You should have received a copy of the GNU General Public License version 3
 *  along with this work; if not, see http://www.gnu.org/licenses/gpl-3.0.txt 
 *
 *  Please contact visnow.org or visit www.visnow.org if you need additional information or
 *  have any questions.
 *
 */

package org.visnow.vn.lib.utils.flowVisualizationUtils;

import static org.apache.commons.math3.util.FastMath.*;

import org.apache.log4j.Logger;

import java.awt.CardLayout;
import java.util.Arrays;
import java.util.Hashtable;
import javax.swing.ImageIcon;
import javax.swing.JLabel;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

import org.visnow.jscic.Field;
import org.visnow.jscic.dataarrays.DataArray;
import org.visnow.vn.geometries.geometryTemplates.ScalarGlyphTemplates;
import org.visnow.vn.geometries.geometryTemplates.VectorGlyphTemplates;
import org.visnow.vn.gui.events.StringValueModificationEvent;
import org.visnow.vn.gui.events.StringValueModificationListener;

/**
 *
 * @author Krzysztof S. Nowinski, University of Warsaw, ICM
 * 
 * Revisions above 395 modified by Szymon Jaranowski (s.jaranowski@icm.edu.pl),
 * University of Warsaw, Interdisciplinary Centre for Mathematical and Computational Modelling
 */
public class GlyphFlowGUI extends javax.swing.JPanel
{
    private static final Logger LOGGER = Logger.getLogger(GlyphFlowGUI.class);
    
    private GlyphFlowParams params = new GlyphFlowParams();
    
    private Field inField = null;
    private String selectedVectorComponentName = "";
    
    private Hashtable<Integer, JLabel> downLabels = new Hashtable<>();
    private int[] down = {1, 2, 5, 10, 20, 50, 100};
    private String[] downTexts = {"1", "", "", "10", "", "", "100"};
    private float smax = 1;
    private int[] downsize;
    private int mode = GlyphFlowParams.STOP;
    private ImageIcon fwdIcon = new javax.swing.ImageIcon(getClass().getResource("/org/visnow/vn/gui/icons/fwd.png"));
    private ImageIcon selFwdIcon = new javax.swing.ImageIcon(getClass().getResource("/org/visnow/vn/gui/icons/selfwd.png"));
    
    private int[] oldDims = null;
    
    protected ChangeListener animationStateListener = new ChangeListener()
    {
        @Override
        public void stateChanged(ChangeEvent e)
        {
            animateToggle.setSelected(false);
        }
    };
    
    public GlyphFlowGUI()
    {
        initComponents();
        
        for (int i = 0; i < downTexts.length; i++) {
            downLabels.put(i, new JLabel(downTexts[i]));
            downLabels.get(i).setFont(new java.awt.Font("Dialog", 0, 8));
        }
        downsizeSlider.setLabelTable(downLabels);
        mapComboBox.setAddNullComponent(true);
        mapComboBox.setTitle("glyph size component");
        glyphComboBox.setModel(new javax.swing.DefaultComboBoxModel(ScalarGlyphTemplates.getGlyphNames()));
        animateToggle.setSelectedIcon(selFwdIcon);
    }

    /**
     * This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents()
    {
        java.awt.GridBagConstraints gridBagConstraints;

        uiStyleFakeInitializer1 = new org.visnow.vn.system.swing.UIStyleFakeInitializer();
        buttonGroup1 = new javax.swing.ButtonGroup();
        mapComboBox = new org.visnow.vn.lib.gui.DataComponentSelector();
        glyphComboBox = new javax.swing.JComboBox();
        lodSlider = new javax.swing.JSlider();
        sqrtBox = new javax.swing.JCheckBox();
        scaleSlider = new org.visnow.vn.gui.widgets.ExtendedSlider();
        constantDiamBox = new javax.swing.JCheckBox();
        glyphPanelFiller = new javax.swing.Box.Filler(new java.awt.Dimension(0, 0), new java.awt.Dimension(0, 0), new java.awt.Dimension(0, 0));
        jPanel1 = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        batchSpinner = new javax.swing.JSpinner();
        jPanel2 = new javax.swing.JPanel();
        resetButton = new javax.swing.JButton();
        animateToggle = new javax.swing.JToggleButton();
        jPanel3 = new javax.swing.JPanel();
        onceButton = new javax.swing.JRadioButton();
        cycleButton = new javax.swing.JRadioButton();
        contButton = new javax.swing.JRadioButton();
        delaySlider = new javax.swing.JSlider();
        downsizeSlider = new javax.swing.JSlider();

        addComponentListener(new java.awt.event.ComponentAdapter()
        {
            public void componentResized(java.awt.event.ComponentEvent evt)
            {
                formComponentResized(evt);
            }
        });
        setLayout(new java.awt.GridBagLayout());

        mapComboBox.setPreferredSize(new java.awt.Dimension(200, 40));
        mapComboBox.addChangeListener(new javax.swing.event.ChangeListener()
        {
            public void stateChanged(javax.swing.event.ChangeEvent evt)
            {
                mapComboBoxStateChanged(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.FIRST_LINE_START;
        gridBagConstraints.weightx = 1.0;
        add(mapComboBox, gridBagConstraints);

        glyphComboBox.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "sphere", "cone", "diamond" }));
        glyphComboBox.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "glyph", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Dialog", 0, 10))); // NOI18N
        glyphComboBox.setMinimumSize(new java.awt.Dimension(84, 40));
        glyphComboBox.setPreferredSize(new java.awt.Dimension(100, 40));
        glyphComboBox.addItemListener(new java.awt.event.ItemListener()
        {
            public void itemStateChanged(java.awt.event.ItemEvent evt)
            {
                glyphComboBoxItemStateChanged(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.FIRST_LINE_START;
        gridBagConstraints.weightx = 1.0;
        add(glyphComboBox, gridBagConstraints);

        lodSlider.setFont(new java.awt.Font("Dialog", 0, 10)); // NOI18N
        lodSlider.setMajorTickSpacing(5);
        lodSlider.setMaximum(20);
        lodSlider.setMinorTickSpacing(1);
        lodSlider.setPaintTicks(true);
        lodSlider.setSnapToTicks(true);
        lodSlider.setValue(1);
        lodSlider.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "glyph smoothness", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Dialog", 0, 10))); // NOI18N
        lodSlider.setPreferredSize(new java.awt.Dimension(150, 50));
        lodSlider.addChangeListener(new javax.swing.event.ChangeListener()
        {
            public void stateChanged(javax.swing.event.ChangeEvent evt)
            {
                lodSliderStateChanged(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        add(lodSlider, gridBagConstraints);

        sqrtBox.setText("<html>square root scale");
        sqrtBox.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        sqrtBox.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                sqrtBoxActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.FIRST_LINE_START;
        gridBagConstraints.weightx = 1.0;
        add(sqrtBox, gridBagConstraints);

        scaleSlider.setFieldType(org.visnow.vn.gui.components.NumericTextField.FieldType.FLOAT);
        scaleSlider.setMax(100);
        scaleSlider.setMin(1);
        scaleSlider.setScaleType(org.visnow.vn.gui.widgets.ExtendedSlider.ScaleType.LOGARITHMIC);
        scaleSlider.setValue(2);
        scaleSlider.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "glyph scale", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Dialog", 0, 10))); // NOI18N
        scaleSlider.setMinimumSize(new java.awt.Dimension(65, 65));
        scaleSlider.setPreferredSize(new java.awt.Dimension(200, 65));
        scaleSlider.addUserActionListener(new org.visnow.vn.gui.swingwrappers.UserActionListener()
        {
            public void userChangeAction(org.visnow.vn.gui.swingwrappers.UserEvent evt)
            {
                scaleSliderUserChangeAction(evt);
            }
            public void userAction(org.visnow.vn.gui.swingwrappers.UserEvent evt)
            {
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.FIRST_LINE_START;
        add(scaleSlider, gridBagConstraints);

        constantDiamBox.setText("<html>constant <p>size glyphs");
        constantDiamBox.setActionCommand("<html>constant size glyphs");
        constantDiamBox.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                constantDiamBoxActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.FIRST_LINE_START;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(0, 4, 0, 0);
        add(constantDiamBox, gridBagConstraints);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 8;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weighty = 1.0;
        add(glyphPanelFiller, gridBagConstraints);

        jPanel1.setBorder(javax.swing.BorderFactory.createEtchedBorder());
        jPanel1.setLayout(new java.awt.GridBagLayout());

        jLabel1.setText("number of batches");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(0, 7, 0, 0);
        jPanel1.add(jLabel1, gridBagConstraints);

        batchSpinner.setModel(new javax.swing.SpinnerNumberModel(1, 1, 50, 1));
        batchSpinner.addChangeListener(new javax.swing.event.ChangeListener()
        {
            public void stateChanged(javax.swing.event.ChangeEvent evt)
            {
                batchSpinnerStateChanged(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(0, 13, 0, 0);
        jPanel1.add(batchSpinner, gridBagConstraints);

        jPanel2.setLayout(new java.awt.GridLayout(1, 0));

        resetButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/org/visnow/vn/gui/icons/tofirst.png"))); // NOI18N
        resetButton.setText("reset");
        resetButton.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                resetButtonActionPerformed(evt);
            }
        });
        jPanel2.add(resetButton);

        animateToggle.setIcon(new javax.swing.ImageIcon(getClass().getResource("/org/visnow/vn/gui/icons/fwd.png"))); // NOI18N
        animateToggle.setText("animate");
        animateToggle.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                animateToggleActionPerformed(evt);
            }
        });
        jPanel2.add(animateToggle);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        jPanel1.add(jPanel2, gridBagConstraints);

        buttonGroup1.add(onceButton);
        onceButton.setSelected(true);
        onceButton.setText("once");
        onceButton.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                onceButtonActionPerformed(evt);
            }
        });
        jPanel3.add(onceButton);

        buttonGroup1.add(cycleButton);
        cycleButton.setText("cycle");
        cycleButton.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                cycleButtonActionPerformed(evt);
            }
        });
        jPanel3.add(cycleButton);

        buttonGroup1.add(contButton);
        contButton.setText("continuous");
        contButton.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                contButtonActionPerformed(evt);
            }
        });
        jPanel3.add(contButton);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        jPanel1.add(jPanel3, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 6;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        add(jPanel1, gridBagConstraints);

        delaySlider.setFont(new java.awt.Font("Dialog", 0, 10)); // NOI18N
        delaySlider.setMajorTickSpacing(10);
        delaySlider.setMaximum(50);
        delaySlider.setMinorTickSpacing(1);
        delaySlider.setBorder(javax.swing.BorderFactory.createTitledBorder("slow down animation"));
        delaySlider.addChangeListener(new javax.swing.event.ChangeListener()
        {
            public void stateChanged(javax.swing.event.ChangeEvent evt)
            {
                delaySliderStateChanged(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 7;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        add(delaySlider, gridBagConstraints);

        downsizeSlider.setFont(new java.awt.Font("Dialog", 0, 8)); // NOI18N
        downsizeSlider.setMajorTickSpacing(1);
        downsizeSlider.setMaximum(9);
        downsizeSlider.setMinorTickSpacing(1);
        downsizeSlider.setPaintLabels(true);
        downsizeSlider.setPaintTicks(true);
        downsizeSlider.setSnapToTicks(true);
        downsizeSlider.setBorder(javax.swing.BorderFactory.createTitledBorder("downsize"));
        downsizeSlider.addChangeListener(new javax.swing.event.ChangeListener()
        {
            public void stateChanged(javax.swing.event.ChangeEvent evt)
            {
                downsizeSliderStateChanged(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        add(downsizeSlider, gridBagConstraints);
    }// </editor-fold>//GEN-END:initComponents
    

    private void scaleSliderStateChanged(javax.swing.event.ChangeEvent evt)//GEN-FIRST:event_scaleSliderStateChanged
    {//GEN-HEADEREND:event_scaleSliderStateChanged
        params.setScale(scaleSlider.getValue().floatValue());
    }//GEN-LAST:event_scaleSliderStateChanged

    private void formComponentResized(java.awt.event.ComponentEvent evt) {//GEN-FIRST:event_formComponentResized

    }//GEN-LAST:event_formComponentResized

    private void delaySliderStateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_delaySliderStateChanged
        params.setDelay(50 - delaySlider.getValue());
    }//GEN-LAST:event_delaySliderStateChanged

    private void contButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_contButtonActionPerformed
        modeChanged();
    }//GEN-LAST:event_contButtonActionPerformed

    private void cycleButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cycleButtonActionPerformed
        modeChanged();
    }//GEN-LAST:event_cycleButtonActionPerformed

    private void onceButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_onceButtonActionPerformed
        modeChanged();
    }//GEN-LAST:event_onceButtonActionPerformed

    private void animateToggleActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_animateToggleActionPerformed
        params.setAnimate(animateToggle.isSelected() ? GlyphFlowParams.FORWARD : GlyphFlowParams.STOP);
    }//GEN-LAST:event_animateToggleActionPerformed

    private void resetButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_resetButtonActionPerformed
        setStopAnimation();//GEN-HEADEREND:event_resetButtonActionPerformed
        params.setAnimate(GlyphFlowParams.RESET);
    }//GEN-LAST:event_resetButtonActionPerformed

    private void batchSpinnerStateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_batchSpinnerStateChanged
        params.setNBatches((Integer)batchSpinner.getValue());
    }//GEN-LAST:event_batchSpinnerStateChanged

    private void constantDiamBoxActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_constantDiamBoxActionPerformed
        setScaleMinMax();
        params.setConstantGlyphSize(constantDiamBox.isSelected());
    }//GEN-LAST:event_constantDiamBoxActionPerformed

    private void downsizeSliderStateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_downsizeSliderStateChanged
        setStopAnimation();//GEN-HEADEREND:event_downsizeSliderStateChanged
        if (!downsizeSlider.getValueIsAdjusting()) {
            if (downsize == null)
                downsize = new int[1];
            downsize[0] = down[Math.max(0, Math.min(down.length -1, downsizeSlider.getValue()))];
            params.setDown(downsize);
        }
    }//GEN-LAST:event_downsizeSliderStateChanged

    private void scaleSliderUserChangeAction(org.visnow.vn.gui.swingwrappers.UserEvent evt) {//GEN-FIRST:event_scaleSliderUserChangeAction
        params.setScale((Float)scaleSlider.getValue());
    }//GEN-LAST:event_scaleSliderUserChangeAction

    private void sqrtBoxActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_sqrtBoxActionPerformed
        params.setUseSqrt(sqrtBox.isSelected());
    }//GEN-LAST:event_sqrtBoxActionPerformed

    private void lodSliderStateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_lodSliderStateChanged
        setStopAnimation();//GEN-HEADEREND:event_lodSliderStateChanged
        if (!lodSlider.getValueIsAdjusting())
            params.setLevelOfDetail(lodSlider.getValue());
    }//GEN-LAST:event_lodSliderStateChanged

    private void glyphComboBoxItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_glyphComboBoxItemStateChanged
        setStopAnimation();//GEN-HEADEREND:event_glyphComboBoxItemStateChanged
        params.setGlyphType(glyphComboBox.getSelectedIndex());
    }//GEN-LAST:event_glyphComboBoxItemStateChanged

    private void mapComboBoxStateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_mapComboBoxStateChanged
        params.setActive(false);
        int m = mapComboBox.getComponent();
        params.setComponent(m);
        if (inField.getComponent(m) == null || inField.getComponent(m).getVectorLength() == 1)
            glyphComboBox.setModel(new javax.swing.DefaultComboBoxModel(ScalarGlyphTemplates.getGlyphNames()));
        else {
            glyphComboBox.setModel(new javax.swing.DefaultComboBoxModel(VectorGlyphTemplates.getGlyphNames()));
            glyphComboBox.setSelectedItem("cone");
        }
        params.setGlyphType(glyphComboBox.getSelectedIndex());
        if (m >= 0)
            setScaleMinMax();
        params.setActive(true);
    }//GEN-LAST:event_mapComboBoxStateChanged

    private void modeChanged()
    {
        setStopAnimation();
        if (onceButton.isSelected())
            params.setAnimationType(GlyphFlowParams.ONCE);
        if (cycleButton.isSelected())
            params.setAnimationType(GlyphFlowParams.CYCLE);
        if (contButton.isSelected())
            params.setAnimationType(GlyphFlowParams.CONTINUOUS);
    }
    
    private String[] lastInComponents = null;

    private boolean componentsChanged(String[] inComponents)
    {
        if (lastInComponents == null || lastInComponents.length != inComponents.length) {
            lastInComponents = inComponents;
            return true;
        }
        for (int i = 0; i < inComponents.length; i++)
            if (inComponents[i].compareTo(lastInComponents[i]) != 0)
                return true;
        return false;
    }

    public void setInData(Field inField, int[] dims)
    {
        setStopAnimation();
        params.setActive(false);
        this.inField = inField;
        String[] inComponents = new String[inField.getNComponents()];
        for (int i = 0; i < inField.getNComponents(); i++)
            inComponents[i] = inField.getComponent(i).getName();
        if (componentsChanged(inComponents)) {
            mapComboBox.setDataSchema(inField.getSchema());
            params.setComponent(mapComboBox.getComponent());
            DataArray mapData = inField.getComponent(mapComboBox.getComponent());
            if (mapData == null || mapData.getVectorLength() == 1)
                glyphComboBox.setModel(new javax.swing.DefaultComboBoxModel(ScalarGlyphTemplates.getGlyphNames()));
            else {
                    glyphComboBox.setModel(new javax.swing.DefaultComboBoxModel(VectorGlyphTemplates.getGlyphNames()));
                    glyphComboBox.setSelectedItem("cone");
                }
            params.setGlyphType(glyphComboBox.getSelectedIndex());
        }
        setScaleMinMax();
        params.setActive(true);
    }

    private void setScaleMinMax()
    {
        float max = 1;
        if (inField.getComponent(params.getComponent()) != null) 
            max = (float)inField.getComponent(params.getComponent()).getPreferredMaxValue();
        float[][] ext = inField.getExtents();
        double diam = 0;
        for (int i = 0; i < 3; i++)
            diam += (ext[1][i] - ext[0][i]) * (ext[1][i] - ext[0][i]);
        if (max <= 0)
            max = .001f;
        smax = (float) (sqrt(diam / 30) / max);
        if (params.isUseSqrt())
            smax /= (float) sqrt((double) smax);
        scaleSlider.setMax(smax);
        scaleSlider.setMin(smax / 100);
        scaleSlider.setValue(smax / 10);
        params.setScale(smax / 10);
    }

    public void setParams(GlyphFlowParams params)
    {
        this.params = params;
    }

    public void setSelectedVectorComponentName(String selectedVectorComponentName)
    {
        this.selectedVectorComponentName = selectedVectorComponentName;
        mapComboBox.setComponentName(selectedVectorComponentName);
    }
    
    StringValueModificationListener vectorComponentChangeListener = new StringValueModificationListener()
    {
        @Override
        public void stringValueChanged(StringValueModificationEvent e)
        {
            selectedVectorComponentName = e.getVal();
            setStopAnimation();
            mapComboBox.setComponentName(selectedVectorComponentName);
        }
    };

    public StringValueModificationListener getVectorComponentChangeListener()
    {
        return vectorComponentChangeListener;
    }
    
    public void setStopAnimation()
    {
        animateToggle.setSelected(false);
        if (params != null)
            params.setAnimate(GlyphFlowParams.STOP); 
    }

    public ChangeListener getAnimationStateListener()
    {
        return animationStateListener;
    }
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JToggleButton animateToggle;
    private javax.swing.JSpinner batchSpinner;
    private javax.swing.ButtonGroup buttonGroup1;
    private javax.swing.JCheckBox constantDiamBox;
    private javax.swing.JRadioButton contButton;
    private javax.swing.JRadioButton cycleButton;
    private javax.swing.JSlider delaySlider;
    private javax.swing.JSlider downsizeSlider;
    private javax.swing.JComboBox glyphComboBox;
    private javax.swing.Box.Filler glyphPanelFiller;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JSlider lodSlider;
    private org.visnow.vn.lib.gui.DataComponentSelector mapComboBox;
    private javax.swing.JRadioButton onceButton;
    private javax.swing.JButton resetButton;
    private org.visnow.vn.gui.widgets.ExtendedSlider scaleSlider;
    private javax.swing.JCheckBox sqrtBox;
    private org.visnow.vn.system.swing.UIStyleFakeInitializer uiStyleFakeInitializer1;
    // End of variables declaration//GEN-END:variables
}
